<?php
/**
 * oa-php-sdk
 * 得力oa接口示例代码
 * 示例
 * 
 * @author tianlun ai
 */
require "base_sdk.php";
/**
 * 实例
 * 
 */
class ApiService extends BaseApiService
{
  public function __construct($config) {
    parent::__construct($config);
  }

  /**
   * 实例 - 创建根部门
   */
  public function departmentInitApi() {
    $api = new ApiService(array(
      'appKey'  => '6919d70abd46487edd06ac2ed5422b7a',
      'appSecret' => 'clkhmps2nv7ohvlgpg9cdciplighvvnz',
    ));
    $params['department_ext_id'] = '1';
    $api->departmentInit($headers = array(), $params);
  }

  /**
   * 实例 - 分页查询部门数据
   */
  public function departmentQueryApi() {
    $api = new ApiService(array(
      'appKey'  => '6919d70abd46487edd06ac2ed5422b7a',
      'appSecret' => 'clkhmps2nv7ohvlgpg9cdciplighvvnz',
    ));
    $params['department_ext_id'] = '1';
    $params['limit'] = 20;
    $params['offset'] = 0;
    $api->departmentQuery($headers = array(), $params);
  }

  /**
   * 实例 - 更新部门数据
   */
  public function departmentUpdateApi() {
    $api = new ApiService(array(
      'appKey'  => '6919d70abd46487edd06ac2ed5422b7a',
      'appSecret' => 'clkhmps2nv7ohvlgpg9cdciplighvvnz',
    ));
    $params['department_ext_id'] = "2";
    $params['name'] = "设计部";
    $params['p_ext_id'] = "1";
    $api->departmentUpdate($headers = array(), $params);
  }

  /**
   * 实例 - 为部门设置外部ID
   */
  public function departmentSetExtApi() {
    $api = new ApiService(array(
      'appKey'  => '6919d70abd46487edd06ac2ed5422b7a',
      'appSecret' => 'clkhmps2nv7ohvlgpg9cdciplighvvnz',
    ));
    $params['id'] = '1';
    $params['ext_id'] = '1';
    $api->departmentSetExt($headers = array(), $params);
  }

  /**
   * 实例 - 删除部门
   */
  public function departmentDeleteApi() {
    $api = new ApiService(array(
      'appKey'  => '6919d70abd46487edd06ac2ed5422b7a',
      'appSecret' => 'clkhmps2nv7ohvlgpg9cdciplighvvnz',
    ));
    $params['ext_id'] = '1';
    $api->departmentDelete($headers = array(), $params);
  }

  /**
   * 实例 - 分页查询部门成员数据
   */
  public function employeeQueryApi() {
    $api = new ApiService(array(
      'appKey'  => '6919d70abd46487edd06ac2ed5422b7a',
      'appSecret' => 'clkhmps2nv7ohvlgpg9cdciplighvvnz',
    ));
    $params['limit'] = 20;
    $params['offset'] = 0;
    $api->employeeQuery($headers = array(), $params);
  }

  /**
   * 实例 - 更新成员数据
   */
  public function employeeUpdateApi() {
    $api = new ApiService(array(
      'appKey'  => '6919d70abd46487edd06ac2ed5422b7a',
      'appSecret' => 'clkhmps2nv7ohvlgpg9cdciplighvvnz',
    ));
    $params = array(
      "employee_ext_id" => "2",             // 此员工在外部接入系统中的id，必填
      "name" => "张三",            // 此员工的名称，必填
      "mobile" => "18600000000",  // 此员工在外部接入系统中的手机号，必填
      "employee_num" => "001", // 此员工在外部接入系统中的工号，必填
      "department_infos" => [array(
        "ext_id" => "2",     // 员工所属部门在外部接入系统中的id
        "title" => "经理"    // 员工在所属部门中的职位
      )]
    );
    $api->employeeUpdate($headers = array(), $params);
  }

  /**
   * 实例 - 为员工设置外部ID
   */
  public function employeeSetExtApi() {
    $api = new ApiService(array(
      'appKey'  => '6919d70abd46487edd06ac2ed5422b7a',
      'appSecret' => 'clkhmps2nv7ohvlgpg9cdciplighvvnz',
    ));
    $params['id'] = '1';
    $params['ext_id'] = '10001';
    $api->employeeSetExt($headers = array(), $params);
  }

  /**
   * 实例 - 删除员工
   */
  public function employeeDeleteApi() {
    $api = new ApiService(array(
      'appKey'  => '6919d70abd46487edd06ac2ed5422b7a',
      'appSecret' => 'clkhmps2nv7ohvlgpg9cdciplighvvnz',
    ));
    $params['employee_ext_id'] = '10001';
    $api->employeeDelete($headers = array(), $params);
  }

  /**
   * 实例 - 人员特征更新
   */
  public function cloudappUpdateApi() {
    $api = new ApiService(array(
      'appKey'  => '6919d70abd46487edd06ac2ed5422b7a',
      'appSecret' => 'clkhmps2nv7ohvlgpg9cdciplighvvnz',
    ));
    $headers = array(
      "Api-Module" => "KQ",
      "Api-Cmd" => "checkin_query",
    );
  
    $params = array(
      "users" => [array(
        "ext_id" => "2",
        "feature_type" => "fa",
        "feature_alg" => "base64",
        "feature_value" => []
      )]
    );
    $api->cloudappUpdate($headers, $params);
  }

  /**
   * 实例 - 查询打卡数据
   */
  public function checkinQueryApi() {
    $api = new ApiService(array(
      'appKey'  => '6919d70abd46487edd06ac2ed5422b7a',
      'appSecret' => 'clkhmps2nv7ohvlgpg9cdciplighvvnz',
    ));
    // 查询打卡数据
    $headers = array(
      "Api-Module" => "KQ",
      "Api-Cmd" => "checkin_query",
    );
    $params["next_id"] = 0;
    $params["page_size"] = 50;
    $api->checkinQuery($headers, $params);
  }
}
?>